import { TZDate } from './tuical/toastui-calendar';

import { addDate, addHours, diffDays, subDate, subtractDate } from './utils';

const today = new TZDate();

/*
drop class /matrix/system/calendar;
create class if not exists /matrix/system/calendar (
  name              varchar,
  title             varchar,
  desc              varchar,  
  calid             varchar,
  catid             varchar,
  calstart          timestamp,
  calend            timestamp,
  repeatcount       int,
  repeattype        varchar,
  periodstartmonth  int,
  periodstartweek   int,
  periodstartdate   int,
  periodstarthour   int,
  periodstartminute int,
  periodexclude     set<varchar>,
  keys(name)
) with autosearch=false, version=true, alias='calendar';
*/

/*
// 输入输出参数格式化
input = INPUT;
output = {};
try {
    input = decodeURIComponent(input);
} catch (e) { }
try {
    input = base64.decode(input);
} catch (e) { }
try {
    input = JSON.parse(input);
    input = JSON.parse(input); // 解析可能存在的重复编码
} catch (e) { }

// 主执行阶段
try {
    main(input, output);
} catch (e) {
    // 错误信息输出处理，抛出 ok 表示正常结束    
    if (e != "ok") {
        if (typeof (e) == "object") {
            output.error = e;
        } else if (typeof (e) == "string") {
            output.error = "错误：" + e;
        } else {
            output.error = JSON.stringify(e);
        }
        log.error(output.error);
        STATUS = "error";
    }
}

function main(input,output) {
    var mql = "select * from /matrix/system/calendar";
    if (input.year && input.month) {
        var nyear = input.year;
        var nmonth = input.month + 1;
        if (nmonth > 12) {
            nmonth -= 12;
            nyear += 1;
        }
        mql += " where calstart < '" + nyear + "-" + nmonth + "-15'";
        var pyear = input.year;
        var pmonth = input.month - 1;
        if (pmonth < 1) {
            pmonth += 12;
            pyear -= 1;
        }
        mql += " and calend > '" + pyear + "-" + pmonth + "-15'";
    }
    var ret = odb.mql(mql);
    output.data = [];
    
    for (var i = 0; i < ret.data.length; i++) {
        output.data.push({
            id: ret.data[i].name,
            title: ret.data[i].title,
            body: ret.data[i].desc,
            start: ret.data[i].calstart,
            end: ret.data[i].calend,
            calendarId: ret.data[i].calid,
            category: ret.data[i].catid,
            repeatcount: ret.data[i].repeatcount,
            repeattype: ret.data[i].repeattype,
            periodstartmonth: ret.data[i].periodstartmonth,
            periodstartweek: ret.data[i].periodstartweek,
            periodstartdate: ret.data[i].periodstartdate,
            periodstarthour: ret.data[i].periodstarthour,
            periodstartminute: ret.data[i].periodstartminute,
            periodexclude: ret.data[i].periodexclude,
        });
    }
}

// 返回输出信息
OUTPUT = output;
*/

/*
// 输入输出参数格式化
input = INPUT;
output = {};
try {
    input = decodeURIComponent(input);
} catch (e) { }
try {
    input = base64.decode(input);
} catch (e) { }
try {
    input = JSON.parse(input);
    input = JSON.parse(input); // 解析可能存在的重复编码
} catch (e) { }

// 主执行阶段
try {
    main(input, output);
} catch (e) {
    // 错误信息输出处理，抛出 ok 表示正常结束    
    if (e != "ok") {
        if (typeof (e) == "object") {
            output.error = e;
        } else if (typeof (e) == "string") {
            output.error = "错误：" + e;
        } else {
            output.error = JSON.stringify(e);
        }
        log.error(output.error);
        STATUS = "error";
    }
}

function main(input,output) {
    output.param = input;
    var mql = "insert into /matrix/system/calendar";
    mql += "(name, title, desc, calstart, calend, calid, catid, repeatcount, repeattype, periodstartmonth, periodstartweek, periodstartdate, periodstarthour, periodstartminute, periodexclude)";
    mql += "values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
    output.result = odb.mql(mql, 
      input.id, 
      input.title || "", 
      input.body || "", 
      input.start || 0, 
      input.end || 0, 
      input.calendarId || "", 
      input.category || "", 
      input.repeatcount || 0, 
      input.repeattype || "", 
      input.periodstartmonth || 0, 
      input.periodstartweek || 0, 
      input.periodstartdate || 0, 
      input.periodstarthour || 0, 
      input.periodstartminute || 0, 
      input.periodexclude || []);
}

// 返回输出信息
OUTPUT = output;
*/

/*
// 输入输出参数格式化
input = INPUT;
output = {};
try {
    input = decodeURIComponent(input);
} catch (e) { }
try {
    input = base64.decode(input);
} catch (e) { }
try {
    input = JSON.parse(input);
    input = JSON.parse(input); // 解析可能存在的重复编码
} catch (e) { }

// 主执行阶段
try {
    main(input, output);
} catch (e) {
    // 错误信息输出处理，抛出 ok 表示正常结束    
    if (e != "ok") {
        if (typeof (e) == "object") {
            output.error = e;
        } else if (typeof (e) == "string") {
            output.error = "错误：" + e;
        } else {
            output.error = JSON.stringify(e);
        }
        log.error(output.error);
        STATUS = "error";
    }
}

function main(input,output) {
    output.params = input;
    var mql = "delete from /matrix/system/calendar";
    mql += " where name=?";
    output.result = odb.mql(mql, input.id);
}

// 返回输出信息
OUTPUT = output;
*/

/*
* @property {string} [id] - Event id.
* @property {string} [calendarId] - Calendar id.
* @property {string} [title] - Event title.
* @property {string} [body] - Body content of the event.
* @property {string} [isAllday] - Whether the event is all day or not.
* @property {string|number|Date|TZDate} [start] - Start time of the event.
* @property {string|number|Date|TZDate} [end] - End time of the event.
* @property {number} [goingDuration] - Travel time which is taken to go in minutes.
* @property {number} [comingDuration] - Travel time which is taken to come back in minutes.
* @property {string} [location] - Location of the event.
* @property {Array.<string>} [attendees] - Attendees of the event.
* @property {string} [category] - Category of the event. Available categories are 'milestone', 'task', 'time' and 'allday'.
* @property {string} [dueDateClass] - Classification of work events. (before work, before lunch, before work)
* @property {string} [recurrenceRule] - Recurrence rule of the event.
* @property {string} [state] - State of the event. Available states are 'Busy', 'Free'.
* @property {boolean} [isVisible] - Whether the event is visible or not.
* @property {boolean} [isPending] - Whether the event is pending or not.
* @property {boolean} [isFocused] - Whether the event is focused or not.
* @property {boolean} [isReadOnly] - Whether the event is read only or not.
* @property {boolean} [isPrivate] - Whether the event is private or not.
*/

function defaultEvents() {
  return [
    {
      id: '444',
      calendarId: 'work',
      title: '国产化设备投产',
      category: 'allday',
      start: addDate(today, 5),
      end: addDate(today, 15),
    },
    {
      id: '555',
      calendarId: 'rest',
      title: '网银服务变更',
      category: 'time',
      start: addHours(today, 24),
      end: addHours(today, 27),
    },
    {
      id: '777',
      calendarId: 'work',
      title: '离中考还有 ' + function(){
        var x=diffDays(new TZDate(today.getFullYear()+'-06-18'), today)
        if (x<0) {
          x=diffDays(new TZDate((today.getFullYear()+1)+'-06-18'), today)
        }
        return x;
      }() + " 天",
      category: 'milestone',
      start: today,
      end: today,
      isReadOnly: true,
    },
    {
      id: '888',
      calendarId: 'work',
      title: '离高考还有 ' + function(){
        var x=diffDays(new TZDate(today.getFullYear()+'-6-7'), today)
        if (x<0) {
          x=diffDays(new TZDate((today.getFullYear()+1)+'-6-7'), today)
        }
        return x;
      }() + " 天",
      category: 'milestone',
      start: today,
      end: today,
      isReadOnly: true,
    },
    {
      id: '991',
      calendarId: 'work',
      title: '日历功能开发',
      category: 'time',
      start: addHours(today, -72).getTime(),
      end: addHours(today, -24).getTime(),
    },
    {
      id: '993',
      calendarId: 'maintain',
      title: '全天维护',
      category: 'allday',
      start: subtractDate(today, 2),
      end: subtractDate(today, 1),
    },
    {
      id: '994',
      calendarId: 'work',
      title: '报表开发',
      category: 'task',
      start: addHours(today, 48),
      end: addHours(today, 51),
    },
  ];
}

var calendars = [
  {
    id: 'work',
    name: '工作日',
    backgroundColor: '#9e5fff',
    borderColor: '#9e5fff',
    dragBackgroundColor: '#9e5fff',
  },
  {
    id: 'rest',
    name: '休息日',
    backgroundColor: '#00e9ef',
    borderColor: '#00e9ef',
    dragBackgroundColor: '#00e9ef',
  },
  {
    id: 'maintain',
    name: '维护期',
    backgroundColor: '#55a9ff',
    borderColor: '#55a9ff',
    dragBackgroundColor: '#55a9ff',
  },
];

function newIndexEvents() {
  return { "ALL": { name: "所有日历", events: [] } };
}

var allevents = {};
var indexcalendars = {};
var indexevents = newIndexEvents();
var titleidmap = {};
var maxtitleid = 1;

function clearTitleID() {
  titleidmap = {};
  maxtitleid = 1;
}

function getTitleID(title) {
  if (titleidmap[title]) {
    return titleidmap[title];
  }
  titleidmap[title] = "T" + maxtitleid;
  maxtitleid++;
  return titleidmap[title];
}

var newID = function () {
  if (typeof crypto === 'object') {
    if (typeof crypto.randomUUID === 'function') {
      return crypto.randomUUID();
    }
    if (typeof crypto.getRandomValues === 'function' && typeof Uint8Array === 'function') {
      const callback = (c) => {
        const num = Number(c);
        return (num ^ (crypto.getRandomValues(new Uint8Array(1))[0] & (15 >> (num / 4)))).toString(16);
      };
      return ([1e7] + -1e3 + -4e3 + -8e3 + -1e11).replace(/[018]/g, callback);
    }
  }
  let timestamp = new Date().getTime();
  let perforNow = (typeof performance !== 'undefined' && performance.now && performance.now() * 1000) || 0;
  return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, (c) => {
    let random = Math.random() * 16;
    if (timestamp > 0) {
      random = (timestamp + random) % 16 | 0;
      timestamp = Math.floor(timestamp / 16);
    } else {
      random = (perforNow + random) % 16 | 0;
      perforNow = Math.floor(perforNow / 16);
    }
    return (c === 'x' ? random : (random & 0x3) | 0x8).toString(16);
  });
};

var loadCalendarEvents = function (range) {
  let param = encodeURIComponent(JSON.stringify(range));
  m3.callFS("/matrix/calendar/load.js", param).then((res) => {
    //console.log(res)
    for (var i in calendars) {
      indexcalendars[calendars[i].id] = calendars[i];
    }
    if (res.status == "ok" && res.message && res.message.data && res.message.data.length >= 0) {
      allevents = {};
      for (var i in res.message.data) {
        var dat = res.message.data[i];
        // console.log(dat);
        allevents[dat.id] = dat
        for (var i in res.message.calendars) {
          if (indexcalendars[res.message.calendars[i].id]) {
            indexcalendars[res.message.calendars[i].id] = res.message.calendars[i];
            for (var ni = 0; ni < calendars.length; ni++) {
              calendars[ni] = res.message.calendars[i];
            }
          } else {
            calendars.push(res.message.calendars[i]);
            indexcalendars[res.message.calendars[i].id] = res.message.calendars[i];
          }
        }
      }
      var defaultevents = defaultEvents();
      for (var i in defaultevents) {
        allevents[defaultevents[i].id] = defaultevents[i];
      }
      clearTitleID();
      indexevents = newIndexEvents();
      for (var id in allevents) {
        var event = allevents[id];
        if (event.start > event.end) {
          var t = event.end;
          event.end = event.start;
          event.start = t;
        }
        if (!indexevents[event.calendarId]) {
          var cal = indexcalendars[event.calendarId];
          if (cal && cal.name) {
            indexevents[event.calendarId] = { name: "所有" + cal.name, events: [] };
          } else {
            indexevents[event.calendarId] = { name: "all " + event.calendarId, events: [] };
          }
        }
        var tid = getTitleID(event.title);
        if (!indexevents[tid]) {
          indexevents[tid] = { name: event.title, events: [] };
        }
        indexevents[event.calendarId].events.push(event);
        indexevents[tid].events.push(event);
        indexevents["ALL"].events.push(event);
      }
      updateproc();
    }
  }).catch((err) => {
    console.error(err);
  });
}

var calendarEventsLoadedProc;
var onCalendarEventsLoaded = function (fp) {
  calendarEventsLoadedProc = fp;
}

var updateproc = function () {
  var indextitles = [];
  indextitles.push({ id: "ALL", name: indexevents["ALL"].name });
  for (var k in indexcalendars) {
    indextitles.push({ id: k, name: indexcalendars[k].name });
  }
  var titles = Object.keys(titleidmap);
  titles.sort();
  for (var ki = 0; ki < titles.length; ki++) {
    var k = titleidmap[titles[ki]];
    indextitles.push({ id: k, name: indexevents[k].name });
  }
  if (calendarEventsLoadedProc) {
    calendarEventsLoadedProc(indexevents, indextitles, calendars);
  }
}

var updateEvent = function (event) {
  var target = {};
  var newdata = {};
  if (!event.target) {
    target = event.change;
    newdata = target;
  } else {
    target = event.target;
    for (var k in event.target) {
      newdata[k] = event.target[k];
    }
    for (var k in event.change) {
      newdata[k] = event.change[k];
    }
  }
  if (newdata.start.getTime() > newdata.end.getTime()) {
    var t = newdata.end;
    newdata.end = newdata.start;
    newdata.start = t;
  }
  var otid = getTitleID(target.title);
  var ntid = getTitleID(newdata.title);
  if (!indexevents[ntid]) {
    indexevents[ntid] = { name: newdata.title, events: [] };
  }
  var isnew = true;
  for (var i = 0; i < indexevents["ALL"].events.length; i++) {
    if (indexevents["ALL"].events[i].id == target.id) {
      indexevents["ALL"].events[i] = newdata;
      isnew = false;
      break;
    }
  }
  if (isnew) {
    indexevents["ALL"].events.push(newdata);
    indexevents[newdata.calendarId].events.push(newdata);
    indexevents[ntid].events.push(newdata);
  } else {
    for (var i = 0; i < indexevents[target.calendarId].events.length; i++) {
      if (indexevents[target.calendarId].events[i].id == target.id) {
        indexevents[newdata.calendarId].events[i] = newdata;
        break;
      }
    }
    if (otid == ntid) {
      for (var i = 0; i < indexevents[otid].events.length; i++) {
        if (indexevents[otid].events[i].id == target.id) {
          indexevents[otid].events[i] = newdata;
          break;
        }
      }
    } else {
      for (var i = 0; i < indexevents[otid].events.length; i++) {
        if (indexevents[otid].events[i].id == target.id) {
          indexevents[otid].events.splice(i, 1);
          indexevents[ntid].events.push(newdata);
          break;
        }
      }
      if (indexevents[otid].events.length == 0) {
        delete indexevents[otid];
        delete titleidmap[target.title];
      }
    }
  }
  updateproc();
  var sdata = {};
  for (var k in newdata) {
    sdata[k] = newdata[k];
  }
  sdata.start = sdata.start.getTime();
  sdata.end = sdata.end.getTime();
  let param = encodeURIComponent(JSON.stringify(sdata));
  m3.callFS("/matrix/calendar/save.js", param).then((res) => {
    if (res.status != "ok") {
      console.error(res);
    }
  }).catch((err) => {
    console.error(err);
  });
  return indexevents;
}

var deleteEvent = function (event) {
  var target = event.target;
  for (var i = 0; i < indexevents["ALL"].events.length; i++) {
    if (indexevents["ALL"].events[i].id == target.id) {
      indexevents["ALL"].events.splice(i, 1);
      break;
    }
  }
  for (var i = 0; i < indexevents[target.calendarId].events.length; i++) {
    if (indexevents[target.calendarId].events[i].id == target.id) {
      indexevents[target.calendarId].events.splice(i, 1);
      break;
    }
  }
  var tid = getTitleID(target.title);
  for (var i = 0; i < indexevents[tid].events.length; i++) {
    if (indexevents[tid].events[i].id == target.id) {
      indexevents[tid].events.splice(i, 1);
      break;
    }
  }
  if (indexevents[tid].events.length == 0) {
    delete indexevents[tid];
    delete titleidmap[target.title];
  }
  updateproc();
  let param = encodeURIComponent(JSON.stringify(target));
  m3.callFS("/matrix/calendar/delete.js", param).then((res) => {
    if (res.status != "ok") {
      console.error(res);
    }
  }).catch((err) => {
    console.error(err);
  });
  return indexevents;
}

export var events = indexevents, calendars = calendars, newID = newID, loadCalendarEvents = loadCalendarEvents, onCalendarEventsLoaded = onCalendarEventsLoaded, updateEvent = updateEvent, deleteEvent = deleteEvent;
